/**
 * Generated by Apache Royale Compiler from org/apache/royale/html/beads/layouts/TileLayout.as
 * org.apache.royale.html.beads.layouts.TileLayout
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.html.beads.layouts.TileLayout');

goog.require('org.apache.royale.core.IParentIUIBase');
goog.require('org.apache.royale.core.LayoutBase');
goog.require('org.apache.royale.utils.CSSContainerUtils');
goog.require('org.apache.royale.core.IBeadLayout');
goog.require('org.apache.royale.utils.Language');



/**
 *  constructor.
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.0
 * @constructor
 * @extends {org.apache.royale.core.LayoutBase}
 * @implements {org.apache.royale.core.IBeadLayout}
 */
org.apache.royale.html.beads.layouts.TileLayout = function() {
  
  this._columnWidth = Number.NaN;
  this._rowHeight = Number.NaN;
  org.apache.royale.html.beads.layouts.TileLayout.base(this, 'constructor');
};
goog.inherits(org.apache.royale.html.beads.layouts.TileLayout, org.apache.royale.core.LayoutBase);


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.html.beads.layouts.TileLayout', org.apache.royale.html.beads.layouts.TileLayout);


/**
 * @private
 * @type {number}
 */
org.apache.royale.html.beads.layouts.TileLayout.prototype._numColumns = 4;


/**
 * @private
 * @type {number}
 */
org.apache.royale.html.beads.layouts.TileLayout.prototype._columnWidth;


/**
 * @private
 * @type {number}
 */
org.apache.royale.html.beads.layouts.TileLayout.prototype._rowHeight;


/**
 * @copy org.apache.royale.core.IBeadLayout#layout
 * @export
 * @override
 */
org.apache.royale.html.beads.layouts.TileLayout.prototype.layout = function() {
  var /** @type {org.apache.royale.geom.Rectangle} */ paddingMetrics = org.apache.royale.utils.CSSContainerUtils.getPaddingMetrics(this.host);
  var /** @type {org.apache.royale.geom.Rectangle} */ borderMetrics = org.apache.royale.utils.CSSContainerUtils.getBorderMetrics(this.host);
  
  var /** @type {Array} */ children;
  var /** @type {number} */ i = 0;
  var /** @type {number} */ n = 0;
  var /** @type {org.apache.royale.core.UIBase} */ child;
  var /** @type {number} */ xpos;
  var /** @type {number} */ ypos;
  var /** @type {number} */ useWidth;
  var /** @type {number} */ useHeight;
  var /** @type {number} */ adjustedWidth = Math.floor(this.host.width - borderMetrics.left - borderMetrics.right);
  var /** @type {number} */ adjustedHeight = Math.floor(this.host.height - borderMetrics.top - borderMetrics.bottom);
  var /** @type {org.apache.royale.core.IParentIUIBase} */ contentView = org.apache.royale.utils.Language.as(this.layoutView, org.apache.royale.core.IParentIUIBase);
  children = contentView.internalChildren();
  n = children.length;
  if (n === 0)
    return false;
  contentView.element.style["display"] = "flex";
  contentView.element.style["flexFlow"] = "row wrap";
  contentView.element.style["alignContent"] = "flex-start";
  var /** @type {number} */ realN = n;
  for (i = 0; i < n; i++) {
    child = children[i].royale_wrapper;
    if (!child.visible)
      realN--;
  }
  xpos = 0;
  ypos = 0;
  useWidth = this.columnWidth;
  useHeight = this.rowHeight;
  if (isNaN(useWidth)) {
    useWidth = Math.floor(adjustedWidth / this.numColumns);
  }
  if (isNaN(useHeight)) {
    var /** @type {number} */ numRows = Math.ceil(realN / this.numColumns);
    if (this.host.isHeightSizedToContent())
      useHeight = 30;
    else
      useHeight = Math.floor(adjustedHeight / numRows);
  }
  for (i = 0; i < n; i++) {
    child = children[i].royale_wrapper;
    if (!child.visible)
      continue;
    child.setDisplayStyleForLayout('inline-block');
    child.width = useWidth;
    child.height = useHeight;
  }
  return true;
};


org.apache.royale.html.beads.layouts.TileLayout.prototype.get__numColumns = function() {
  return this._numColumns;
};


org.apache.royale.html.beads.layouts.TileLayout.prototype.set__numColumns = function(value) {
  this._numColumns = value;
};


org.apache.royale.html.beads.layouts.TileLayout.prototype.get__columnWidth = function() {
  return this._columnWidth;
};


org.apache.royale.html.beads.layouts.TileLayout.prototype.set__columnWidth = function(value) {
  this._columnWidth = value;
};


org.apache.royale.html.beads.layouts.TileLayout.prototype.get__rowHeight = function() {
  return this._rowHeight;
};


org.apache.royale.html.beads.layouts.TileLayout.prototype.set__rowHeight = function(value) {
  this._rowHeight = value;
};


Object.defineProperties(org.apache.royale.html.beads.layouts.TileLayout.prototype, /** @lends {org.apache.royale.html.beads.layouts.TileLayout.prototype} */ {
/**
  * @export
  * @type {number} */
numColumns: {
get: org.apache.royale.html.beads.layouts.TileLayout.prototype.get__numColumns,
set: org.apache.royale.html.beads.layouts.TileLayout.prototype.set__numColumns},
/**
  * @export
  * @type {number} */
columnWidth: {
get: org.apache.royale.html.beads.layouts.TileLayout.prototype.get__columnWidth,
set: org.apache.royale.html.beads.layouts.TileLayout.prototype.set__columnWidth},
/**
  * @export
  * @type {number} */
rowHeight: {
get: org.apache.royale.html.beads.layouts.TileLayout.prototype.get__rowHeight,
set: org.apache.royale.html.beads.layouts.TileLayout.prototype.set__rowHeight}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.html.beads.layouts.TileLayout.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'TileLayout', qName: 'org.apache.royale.html.beads.layouts.TileLayout', kind: 'class' }], interfaces: [org.apache.royale.core.IBeadLayout] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.html.beads.layouts.TileLayout.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {
      return {
        'numColumns': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.royale.html.beads.layouts.TileLayout'},
        'columnWidth': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.royale.html.beads.layouts.TileLayout'},
        'rowHeight': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.royale.html.beads.layouts.TileLayout'}
      };
    },
    methods: function () {
      return {
        'TileLayout': { type: '', declaredBy: 'org.apache.royale.html.beads.layouts.TileLayout'},
        'layout': { type: 'Boolean', declaredBy: 'org.apache.royale.html.beads.layouts.TileLayout'}
      };
    }
  };
};