/**
 * Generated by Apache Royale Compiler from org/apache/royale/html/beads/layouts/TreeGridLayout.as
 * org.apache.royale.html.beads.layouts.TreeGridLayout
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.html.beads.layouts.TreeGridLayout');

goog.require('org.apache.royale.core.IUIBase');
goog.require('org.apache.royale.core.UIBase');
goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.events.IEventDispatcher');
goog.require('org.apache.royale.html.beads.TreeGridView');
goog.require('org.apache.royale.html.beads.models.ButtonBarModel');
goog.require('org.apache.royale.html.beads.models.TreeGridModel');
goog.require('org.apache.royale.html.supportClasses.TreeGridColumn');
goog.require('org.apache.royale.core.IBeadLayout');
goog.require('org.apache.royale.utils.Language');



/**
 * Constructor.
 * 
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.9
 * @constructor
 * @implements {org.apache.royale.core.IBeadLayout}
 */
org.apache.royale.html.beads.layouts.TreeGridLayout = function() {
};


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.html.beads.layouts.TreeGridLayout', org.apache.royale.html.beads.layouts.TreeGridLayout);


/**
 * @private
 * @type {org.apache.royale.core.IStrand}
 */
org.apache.royale.html.beads.layouts.TreeGridLayout.prototype._strand;


/**
 * @private
 * @param {org.apache.royale.events.Event} event
 */
org.apache.royale.html.beads.layouts.TreeGridLayout.prototype.handleSizeChanges = function(event) {
  this.layout();
};


/**
 * @private
 * @param {org.apache.royale.events.Event} event
 */
org.apache.royale.html.beads.layouts.TreeGridLayout.prototype.handleLayoutNeeded = function(event) {
  this.layout();
};


/**
 * Performs the layout function, placing the ButtonBar header at the top
 * and spread across the width and the columns below that, laid out horizontally.
 * The size of the columns is taken from the TreeGridColumn definitions stored
 * in the TreeGridModel.
 * 
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.9
 * @export
 * @return {boolean}
 */
org.apache.royale.html.beads.layouts.TreeGridLayout.prototype.layout = function() {
  var /** @type {org.apache.royale.html.beads.models.TreeGridModel} */ model = org.apache.royale.utils.Language.as(this.uiHost.model, org.apache.royale.html.beads.models.TreeGridModel);
  var /** @type {org.apache.royale.html.ButtonBar} */ header = org.apache.royale.utils.Language.as(this.uiHost.view, org.apache.royale.html.beads.TreeGridView).header;
  var /** @type {org.apache.royale.core.UIBase} */ contentArea = org.apache.royale.utils.Language.as(this.uiHost.view, org.apache.royale.html.beads.TreeGridView).contentArea;
  var /** @type {Array} */ displayedColumns = org.apache.royale.utils.Language.as(this.uiHost.view, org.apache.royale.html.beads.TreeGridView).displayedColumns;
  header.x = 0;
  header.y = 0;
  header.setWidthAndHeight(this.uiHost.width, 25);
  var /** @type {number} */ xpos = 0;
  var /** @type {number} */ defaultColumnWidth = contentArea.width / model.columns.length;
  var /** @type {Array} */ columnWidths = [];
  for (var /** @type {number} */ i = 0; i < displayedColumns.length; i++) {
    var /** @type {org.apache.royale.html.supportClasses.TreeGridColumn} */ columnDef = org.apache.royale.utils.Language.as(model.columns[i], org.apache.royale.html.supportClasses.TreeGridColumn);
    var /** @type {org.apache.royale.core.UIBase} */ columnList = org.apache.royale.utils.Language.as(displayedColumns[i], org.apache.royale.core.UIBase);
    columnList.x = xpos;
    columnList.y = 0;
    if (isNaN(columnDef.columnWidth)) {
      columnList.width = defaultColumnWidth;
    } else {
      columnList.width = columnDef.columnWidth;
    }
    columnWidths.push(columnList.width);
    xpos += columnList.width;
  }
  var /** @type {org.apache.royale.html.beads.models.ButtonBarModel} */ bbmodel = org.apache.royale.utils.Language.as(header.getBeadByType(org.apache.royale.html.beads.models.ButtonBarModel), org.apache.royale.html.beads.models.ButtonBarModel);
  bbmodel.buttonWidths = columnWidths;
  header.dispatchEvent(new org.apache.royale.events.Event("layoutNeeded"));
  contentArea.x = 0;
  contentArea.y = header.height;
  contentArea.setWidthAndHeight(this.uiHost.width, this.uiHost.height - header.height);
  return true;
};


org.apache.royale.html.beads.layouts.TreeGridLayout.prototype.set__strand = function(value) {
  this._strand = value;
  org.apache.royale.utils.Language.as(this._strand, org.apache.royale.events.IEventDispatcher).addEventListener("widthChanged", org.apache.royale.utils.Language.closure(this.handleSizeChanges, this, 'handleSizeChanges'));
  org.apache.royale.utils.Language.as(this._strand, org.apache.royale.events.IEventDispatcher).addEventListener("heightChanged", org.apache.royale.utils.Language.closure(this.handleSizeChanges, this, 'handleSizeChanges'));
  org.apache.royale.utils.Language.as(this._strand, org.apache.royale.events.IEventDispatcher).addEventListener("sizeChanged", org.apache.royale.utils.Language.closure(this.handleSizeChanges, this, 'handleSizeChanges'));
  org.apache.royale.utils.Language.as(this._strand, org.apache.royale.events.IEventDispatcher).addEventListener("layoutNeeded", org.apache.royale.utils.Language.closure(this.handleLayoutNeeded, this, 'handleLayoutNeeded'));
};


org.apache.royale.html.beads.layouts.TreeGridLayout.prototype.get__host = function() {
  return org.apache.royale.utils.Language.as(this._strand, org.apache.royale.core.IUIBase);
};


org.apache.royale.html.beads.layouts.TreeGridLayout.prototype.get__uiHost = function() {
  return org.apache.royale.utils.Language.as(this._strand, org.apache.royale.core.UIBase);
};


Object.defineProperties(org.apache.royale.html.beads.layouts.TreeGridLayout.prototype, /** @lends {org.apache.royale.html.beads.layouts.TreeGridLayout.prototype} */ {
/**
  * @export
  * @type {org.apache.royale.core.IStrand} */
strand: {
set: org.apache.royale.html.beads.layouts.TreeGridLayout.prototype.set__strand},
/**
  * @export
  * @type {org.apache.royale.core.IUIBase} */
host: {
get: org.apache.royale.html.beads.layouts.TreeGridLayout.prototype.get__host},
/**
  * @export
  * @type {org.apache.royale.core.UIBase} */
uiHost: {
get: org.apache.royale.html.beads.layouts.TreeGridLayout.prototype.get__uiHost}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.html.beads.layouts.TreeGridLayout.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'TreeGridLayout', qName: 'org.apache.royale.html.beads.layouts.TreeGridLayout', kind: 'class' }], interfaces: [org.apache.royale.core.IBeadLayout] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.html.beads.layouts.TreeGridLayout.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {
      return {
        'strand': { type: 'org.apache.royale.core.IStrand', access: 'writeonly', declaredBy: 'org.apache.royale.html.beads.layouts.TreeGridLayout'}
      };
    },
    methods: function () {
      return {
        'TreeGridLayout': { type: '', declaredBy: 'org.apache.royale.html.beads.layouts.TreeGridLayout'},
        'layout': { type: 'Boolean', declaredBy: 'org.apache.royale.html.beads.layouts.TreeGridLayout'}
      };
    }
  };
};