/**
 * Generated by Apache Royale Compiler from org/apache/royale/html/beads/models/DateChooserModel.as
 * org.apache.royale.html.beads.models.DateChooserModel
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.html.beads.models.DateChooserModel');

goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.events.EventDispatcher');
goog.require('org.apache.royale.core.IDateChooserModel');
goog.require('org.apache.royale.utils.Language');



/**
 * @constructor
 * @extends {org.apache.royale.events.EventDispatcher}
 * @implements {org.apache.royale.core.IDateChooserModel}
 */
org.apache.royale.html.beads.models.DateChooserModel = function() {
  org.apache.royale.html.beads.models.DateChooserModel.base(this, 'constructor');

this._dayNames = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];
this._monthNames = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
};
goog.inherits(org.apache.royale.html.beads.models.DateChooserModel, org.apache.royale.events.EventDispatcher);


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.html.beads.models.DateChooserModel', org.apache.royale.html.beads.models.DateChooserModel);


/**
 * @private
 * @type {org.apache.royale.core.IStrand}
 */
org.apache.royale.html.beads.models.DateChooserModel.prototype._strand;


/**
 * @private
 * @type {Array}
 */
org.apache.royale.html.beads.models.DateChooserModel.prototype._dayNames;


/**
 * @private
 * @type {Array}
 */
org.apache.royale.html.beads.models.DateChooserModel.prototype._monthNames;


/**
 * @private
 * @type {Array}
 */
org.apache.royale.html.beads.models.DateChooserModel.prototype._days;


/**
 * @private
 * @type {number}
 */
org.apache.royale.html.beads.models.DateChooserModel.prototype._displayedYear;


/**
 * @private
 * @type {number}
 */
org.apache.royale.html.beads.models.DateChooserModel.prototype._displayedMonth;


/**
 * @private
 * @type {number}
 */
org.apache.royale.html.beads.models.DateChooserModel.prototype._firstDayOfWeek = 0;


/**
 * @private
 * @type {Date}
 */
org.apache.royale.html.beads.models.DateChooserModel.prototype._selectedDate;


/**
 * @asprivate
 * @private
 */
org.apache.royale.html.beads.models.DateChooserModel.prototype.updateCalendar = function() {
  var /** @type {Date} */ firstDay = new Date(this.displayedYear, this.displayedMonth, 1);
  this._days = new Array(42);
  var /** @type {number} */ i = firstDay.getDay();
  var /** @type {number} */ dayNumber = 1;
  var /** @type {number} */ numDays = this.numberOfDaysInMonth(this.displayedMonth, this.displayedYear);
  while (dayNumber <= numDays) {
    this._days[i++] = new Date(this.displayedYear, this.displayedMonth, dayNumber++);
  }
};


/**
 * @asprivate
 * @private
 * @param {number} month
 * @param {number} year
 * @return {number}
 */
org.apache.royale.html.beads.models.DateChooserModel.prototype.numberOfDaysInMonth = function(month, year) {
  var /** @type {number} */ n = 0;
  if (month == 1) {
    if (((year % 4 == 0) && (year % 100 != 0)) || (year % 400 == 0))
      n = 29;
    else
      n = 28;
  }
  else if (month == 3 || month == 5 || month == 8 || month == 10)
    n = 30;
  else
    n = 31;
  return n;
};


/**
 * @asprivate
 * @export
 * @return {number}
 */
org.apache.royale.html.beads.models.DateChooserModel.prototype.getIndexForSelectedDate = function() {
  if (!this._selectedDate)
    return -1;
  var /** @type {string} */ str = this._selectedDate.toDateString();
  for (var /** @type {number} */ i = 0; i < this._days.length; i++) {
    var /** @type {Date} */ test = org.apache.royale.utils.Language.as(this._days[i], Date);
    if (test && test.toDateString() == str)
      return i;
  }
  return -1;
};


org.apache.royale.html.beads.models.DateChooserModel.prototype.set__strand = function(value) {
  this._strand = value;
};


org.apache.royale.html.beads.models.DateChooserModel.prototype.get__dayNames = function() {
  return this._dayNames;
};


org.apache.royale.html.beads.models.DateChooserModel.prototype.set__dayNames = function(value) {
  this._dayNames = value;
  this.dispatchEvent(new org.apache.royale.events.Event("dayNamesChanged"));
};


org.apache.royale.html.beads.models.DateChooserModel.prototype.get__monthNames = function() {
  return this._monthNames;
};


org.apache.royale.html.beads.models.DateChooserModel.prototype.set__monthNames = function(value) {
  this._monthNames = value;
  this.dispatchEvent(new org.apache.royale.events.Event("monthNames"));
};


org.apache.royale.html.beads.models.DateChooserModel.prototype.get__displayedYear = function() {
  return this._displayedYear;
};


org.apache.royale.html.beads.models.DateChooserModel.prototype.set__displayedYear = function(value) {
  if (value != this._displayedYear) {
    this._displayedYear = value;
    this.updateCalendar();
    this.dispatchEvent(new org.apache.royale.events.Event("displayedYearChanged"));
  }
};


org.apache.royale.html.beads.models.DateChooserModel.prototype.get__displayedMonth = function() {
  return this._displayedMonth;
};


org.apache.royale.html.beads.models.DateChooserModel.prototype.set__displayedMonth = function(value) {
  if (this._displayedMonth != value) {
    this._displayedMonth = value;
    this.updateCalendar();
    this.dispatchEvent(new org.apache.royale.events.Event("displayedMonthChanged"));
  }
};


org.apache.royale.html.beads.models.DateChooserModel.prototype.get__firstDayOfWeek = function() {
  return this._firstDayOfWeek;
};


org.apache.royale.html.beads.models.DateChooserModel.prototype.set__firstDayOfWeek = function(value) {
  if (value != this._firstDayOfWeek) {
    this._firstDayOfWeek = value;
    this.dispatchEvent(new org.apache.royale.events.Event("firstDayOfWeekChanged"));
  }
};


org.apache.royale.html.beads.models.DateChooserModel.prototype.get__days = function() {
  return this._days;
};


org.apache.royale.html.beads.models.DateChooserModel.prototype.set__days = function(value) {
  if (value != this._days) {
    this._days = value;
    this.dispatchEvent(new org.apache.royale.events.Event("daysChanged"));
  }
};


org.apache.royale.html.beads.models.DateChooserModel.prototype.get__selectedDate = function() {
  return this._selectedDate;
};


org.apache.royale.html.beads.models.DateChooserModel.prototype.set__selectedDate = function(value) {
  if (value != this._selectedDate) {
    this._selectedDate = value;
    if (value != null) {
      var /** @type {boolean} */ needsUpdate = false;
      if (value.getMonth() != this._displayedMonth) {
        needsUpdate = true;
        this._displayedMonth = value.getMonth();
      }
      if (value.getFullYear() != this._displayedYear) {
        needsUpdate = true;
        this._displayedYear = value.getFullYear();
      }
      if (needsUpdate)
        this.updateCalendar();
    }
    this.dispatchEvent(new org.apache.royale.events.Event("selectedDateChanged"));
  }
};


Object.defineProperties(org.apache.royale.html.beads.models.DateChooserModel.prototype, /** @lends {org.apache.royale.html.beads.models.DateChooserModel.prototype} */ {
/**
  * @export
  * @type {org.apache.royale.core.IStrand} */
strand: {
set: org.apache.royale.html.beads.models.DateChooserModel.prototype.set__strand},
/**
  * @export
  * @type {Array} */
dayNames: {
get: org.apache.royale.html.beads.models.DateChooserModel.prototype.get__dayNames,
set: org.apache.royale.html.beads.models.DateChooserModel.prototype.set__dayNames},
/**
  * @export
  * @type {Array} */
monthNames: {
get: org.apache.royale.html.beads.models.DateChooserModel.prototype.get__monthNames,
set: org.apache.royale.html.beads.models.DateChooserModel.prototype.set__monthNames},
/**
  * @export
  * @type {number} */
displayedYear: {
get: org.apache.royale.html.beads.models.DateChooserModel.prototype.get__displayedYear,
set: org.apache.royale.html.beads.models.DateChooserModel.prototype.set__displayedYear},
/**
  * @export
  * @type {number} */
displayedMonth: {
get: org.apache.royale.html.beads.models.DateChooserModel.prototype.get__displayedMonth,
set: org.apache.royale.html.beads.models.DateChooserModel.prototype.set__displayedMonth},
/**
  * @export
  * @type {number} */
firstDayOfWeek: {
get: org.apache.royale.html.beads.models.DateChooserModel.prototype.get__firstDayOfWeek,
set: org.apache.royale.html.beads.models.DateChooserModel.prototype.set__firstDayOfWeek},
/**
  * @export
  * @type {Array} */
days: {
get: org.apache.royale.html.beads.models.DateChooserModel.prototype.get__days,
set: org.apache.royale.html.beads.models.DateChooserModel.prototype.set__days},
/**
  * @export
  * @type {Date} */
selectedDate: {
get: org.apache.royale.html.beads.models.DateChooserModel.prototype.get__selectedDate,
set: org.apache.royale.html.beads.models.DateChooserModel.prototype.set__selectedDate}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.html.beads.models.DateChooserModel.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'DateChooserModel', qName: 'org.apache.royale.html.beads.models.DateChooserModel', kind: 'class' }], interfaces: [org.apache.royale.core.IDateChooserModel] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.html.beads.models.DateChooserModel.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {
      return {
        'strand': { type: 'org.apache.royale.core.IStrand', access: 'writeonly', declaredBy: 'org.apache.royale.html.beads.models.DateChooserModel'},
        'dayNames': { type: 'Array', access: 'readwrite', declaredBy: 'org.apache.royale.html.beads.models.DateChooserModel'},
        'monthNames': { type: 'Array', access: 'readwrite', declaredBy: 'org.apache.royale.html.beads.models.DateChooserModel'},
        'displayedYear': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.royale.html.beads.models.DateChooserModel'},
        'displayedMonth': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.royale.html.beads.models.DateChooserModel'},
        'firstDayOfWeek': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.royale.html.beads.models.DateChooserModel'},
        'days': { type: 'Array', access: 'readwrite', declaredBy: 'org.apache.royale.html.beads.models.DateChooserModel'},
        'selectedDate': { type: 'Date', access: 'readwrite', declaredBy: 'org.apache.royale.html.beads.models.DateChooserModel'}
      };
    },
    methods: function () {
      return {
        'DateChooserModel': { type: '', declaredBy: 'org.apache.royale.html.beads.models.DateChooserModel'},
        'getIndexForSelectedDate': { type: 'Number', declaredBy: 'org.apache.royale.html.beads.models.DateChooserModel'}
      };
    }
  };
};