/**
 * Generated by Apache Royale Compiler from org/apache/royale/html/beads/models/RangeModel.as
 * org.apache.royale.html.beads.models.RangeModel
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.html.beads.models.RangeModel');

goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.events.EventDispatcher');
goog.require('org.apache.royale.events.ValueChangeEvent');
goog.require('org.apache.royale.core.IBead');
goog.require('org.apache.royale.core.IRangeModel');



/**
 *  constructor.
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.0
 * @constructor
 * @extends {org.apache.royale.events.EventDispatcher}
 * @implements {org.apache.royale.core.IBead}
 * @implements {org.apache.royale.core.IRangeModel}
 */
org.apache.royale.html.beads.models.RangeModel = function() {
  org.apache.royale.html.beads.models.RangeModel.base(this, 'constructor');
};
goog.inherits(org.apache.royale.html.beads.models.RangeModel, org.apache.royale.events.EventDispatcher);


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.html.beads.models.RangeModel', org.apache.royale.html.beads.models.RangeModel);


/**
 * @protected
 * @type {org.apache.royale.core.IStrand}
 */
org.apache.royale.html.beads.models.RangeModel.prototype._strand;


/**
 * @private
 * @type {number}
 */
org.apache.royale.html.beads.models.RangeModel.prototype._maximum = 100;


/**
 * @private
 * @type {number}
 */
org.apache.royale.html.beads.models.RangeModel.prototype._minimum = 0;


/**
 * @private
 * @type {number}
 */
org.apache.royale.html.beads.models.RangeModel.prototype._snapInterval = 1;


/**
 * @private
 * @type {number}
 */
org.apache.royale.html.beads.models.RangeModel.prototype._decimals = 0;


/**
 * @private
 * @type {number}
 */
org.apache.royale.html.beads.models.RangeModel.prototype._stepSize = 1;


/**
 * @private
 * @type {number}
 */
org.apache.royale.html.beads.models.RangeModel.prototype._value = 0;


/**
 * @asprivate
 * @protected
 * @param {number} value
 * @return {number}
 */
org.apache.royale.html.beads.models.RangeModel.prototype.snap = function(value) {
  var /** @type {number} */ si = this.snapInterval;
  var /** @type {number} */ n = Math.round((value - this.minimum) / si) * si + this.minimum;
  if (this._decimals)
    n = Number(n.toFixed(this._decimals));
  if (value > 0) {
    if (value - n < n + si - value)
      return n;
    return n + si;
  }
  if (value - n > n + si - value)
    return n + si;
  return n;
};


org.apache.royale.html.beads.models.RangeModel.prototype.set__strand = function(value) {
  this._strand = value;
};


org.apache.royale.html.beads.models.RangeModel.prototype.get__maximum = function() {
  return this._maximum;
};


org.apache.royale.html.beads.models.RangeModel.prototype.set__maximum = function(value) {
  if (value != this._maximum) {
    this._maximum = value;
    if (this._value > this._maximum)
      this._value = this._maximum;
    this.dispatchEvent(new org.apache.royale.events.Event("maximumChange"));
  }
};


org.apache.royale.html.beads.models.RangeModel.prototype.get__minimum = function() {
  return this._minimum;
};


org.apache.royale.html.beads.models.RangeModel.prototype.set__minimum = function(value) {
  if (value != this._minimum) {
    this._minimum = value;
    if (this._value < this._minimum)
      this._value = this._minimum;
    this.dispatchEvent(new org.apache.royale.events.Event("minimumChange"));
  }
};


org.apache.royale.html.beads.models.RangeModel.prototype.get__snapInterval = function() {
  return this._snapInterval;
};


org.apache.royale.html.beads.models.RangeModel.prototype.set__snapInterval = function(value) {
  if (value != this._snapInterval) {
    this._snapInterval = value;
    this.dispatchEvent(new org.apache.royale.events.Event("snapIntervalChange"));
  }
  if (("" + value).indexOf(".") == -1) {
    this._decimals = 0;
  } else {
    var /** @type {string} */ str = "" + value;
    this._decimals = str.substr(str.indexOf(".") + 1).length;
  }
};


org.apache.royale.html.beads.models.RangeModel.prototype.get__stepSize = function() {
  return this._stepSize;
};


org.apache.royale.html.beads.models.RangeModel.prototype.set__stepSize = function(value) {
  if (value != this._stepSize) {
    this._stepSize = value;
    this.dispatchEvent(new org.apache.royale.events.Event("stepSizeChange"));
  }
};


org.apache.royale.html.beads.models.RangeModel.prototype.get__value = function() {
  return this._value;
};


org.apache.royale.html.beads.models.RangeModel.prototype.set__value = function(newValue) {
  if (newValue != this._value) {
    newValue = Math.max(this.minimum, newValue);
    newValue = Math.min(this.maximum, newValue);
    var /** @type {number} */ oldValue = this._value;
    this._value = this.snap(newValue);
    this.dispatchEvent(org.apache.royale.events.ValueChangeEvent.createUpdateEvent(this._strand, "value", oldValue, this._value));
  }
};


Object.defineProperties(org.apache.royale.html.beads.models.RangeModel.prototype, /** @lends {org.apache.royale.html.beads.models.RangeModel.prototype} */ {
/**
  * @export
  * @type {org.apache.royale.core.IStrand} */
strand: {
set: org.apache.royale.html.beads.models.RangeModel.prototype.set__strand},
/**
  * @export
  * @type {number} */
maximum: {
get: org.apache.royale.html.beads.models.RangeModel.prototype.get__maximum,
set: org.apache.royale.html.beads.models.RangeModel.prototype.set__maximum},
/**
  * @export
  * @type {number} */
minimum: {
get: org.apache.royale.html.beads.models.RangeModel.prototype.get__minimum,
set: org.apache.royale.html.beads.models.RangeModel.prototype.set__minimum},
/**
  * @export
  * @type {number} */
snapInterval: {
get: org.apache.royale.html.beads.models.RangeModel.prototype.get__snapInterval,
set: org.apache.royale.html.beads.models.RangeModel.prototype.set__snapInterval},
/**
  * @export
  * @type {number} */
stepSize: {
get: org.apache.royale.html.beads.models.RangeModel.prototype.get__stepSize,
set: org.apache.royale.html.beads.models.RangeModel.prototype.set__stepSize},
/**
  * @export
  * @type {number} */
value: {
get: org.apache.royale.html.beads.models.RangeModel.prototype.get__value,
set: org.apache.royale.html.beads.models.RangeModel.prototype.set__value}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.html.beads.models.RangeModel.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'RangeModel', qName: 'org.apache.royale.html.beads.models.RangeModel', kind: 'class' }], interfaces: [org.apache.royale.core.IBead, org.apache.royale.core.IRangeModel] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.html.beads.models.RangeModel.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {
      return {
        'strand': { type: 'org.apache.royale.core.IStrand', access: 'writeonly', declaredBy: 'org.apache.royale.html.beads.models.RangeModel'},
        'maximum': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.royale.html.beads.models.RangeModel'},
        'minimum': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.royale.html.beads.models.RangeModel'},
        'snapInterval': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.royale.html.beads.models.RangeModel'},
        'stepSize': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.royale.html.beads.models.RangeModel'},
        'value': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.royale.html.beads.models.RangeModel'}
      };
    },
    methods: function () {
      return {
        'RangeModel': { type: '', declaredBy: 'org.apache.royale.html.beads.models.RangeModel'}
      };
    }
  };
};